#ifndef _TASKBAR_BADGE_H_
#define _TASKBAR_BADGE_H_

#include <windows.h>
#include <comip.h>
#include <comdef.h>
#include <shlobj.h>
#include <objbase.h>
#include <gdiplus.h>

class Taskbar3
{
public:
	typedef enum _BADGE_SIGNTYPE {
		SIGN_NONE,
		SIGN_PLUS,
		SIGN_MINUS,
	} BADGE_SIGNTYPE;

	Taskbar3(void);
	virtual ~Taskbar3(void);
	BOOL Init(void);
	BOOL SetBadge( HWND hWnd, TCHAR *str, BADGE_SIGNTYPE type = SIGN_NONE );
	BOOL SetProgress( HWND hWnd, ULONGLONG ullCompleted, ULONGLONG ullTotal );
	BOOL Flash( HWND hWnd );

protected:
	typedef enum _BADGE_ADDSIGNTYPE {
		ADD_NONE,
		ADD_PLUS_UR,
		ADD_MINUS_UR,
		ADD_MINUS_LEFT,
	} BADGE_ADDSIGNTYPE;
	_COM_SMARTPTR_TYPEDEF(ITaskbarList3, __uuidof(ITaskbarList3));
	ITaskbarList3Ptr taskBar;
	HICON GenerateBadgeIcon( TCHAR *str, BADGE_SIGNTYPE type );
	void AddSign( Gdiplus::Graphics &gr, Gdiplus::FontFamily &ff, Gdiplus::StringFormat &format, BADGE_ADDSIGNTYPE addType );
};

#endif//_TASKBAR_BADGE_H_
