#include "stdafx.h"
#include <windows.h>
#include <shlwapi.h>
#include "misc.h"


SIMPLE_OSVERSION	GetSimpleOSVersion( void )
{
	OSVERSIONINFOEX ver;
	static SIMPLE_OSVERSION soVer = OS_UNKNOWN;

	if ( soVer != OS_UNKNOWN ) return soVer;

	ver.dwOSVersionInfoSize = sizeof(ver);
	GetVersionEx( (LPOSVERSIONINFO)&ver );

	switch( ver.dwPlatformId )
	{
	case VER_PLATFORM_WIN32s:
		soVer = OS_OLD;
		break;

	case VER_PLATFORM_WIN32_WINDOWS:
		soVer = OS_9X;
		break;

	case VER_PLATFORM_WIN32_NT:
		switch( ver.dwMajorVersion )
		{
		case 3:
			soVer = OS_OLD;
			break;

		case 4:
			soVer = OS_NT4;
			break;

		case 5:
			switch( ver.dwMinorVersion )
			{
			case 0:
				soVer = OS_2000;
				break;

			case 1:
				soVer = OS_XP;
				break;

			case 2:
				switch( ver.wProductType )
				{
				case VER_NT_WORKSTATION:
					soVer = OS_XP;
					break;

				default:
					soVer = OS_S2003;
					break;
				}
				break;

			default:
				soVer = OS_NEWER;
				break;
			}
			break;

		case 6:
			switch( ver.dwMinorVersion )
			{
			case 0:
				switch( ver.wProductType )
				{
				case VER_NT_WORKSTATION:
					soVer = OS_VISTA;
					break;

				default:
					soVer = OS_S2008;
					break;
				}
				break;

			case 1:
				switch( ver.wProductType )
				{
				case VER_NT_WORKSTATION:
					soVer = OS_7;
					break;

				default:
					soVer = OS_S2008R2;
					break;
				}
				break;

			case 2:
				switch( ver.wProductType )
				{
				case VER_NT_WORKSTATION:
					soVer = OS_8;
					break;

				default:
					soVer = OS_S2012;
					break;
				}
				break;

			default:
				soVer = OS_NEWER;
				break;
			}
			break;

		default:
			soVer = OS_NEWER;
			break;
		}
		break;
	}

	return soVer;
}

int MessageBoxWithString(HWND hWnd, UINT uID, UINT nType, DWORD dwErr)
{
	TCHAR tcError[10], *temp = NULL;
	int nRet, n = 0;

	do {
		if ( temp ) {
			delete[] temp;
		}
		n += 1024;
		temp = new TCHAR[n + 10];
		nRet = LoadString( hInst, uID, temp, n );
	} while( ( nRet + 1 ) == n );

	if ( dwErr != 0 ) {
		_stprintf_s( tcError, _T(":%x"), dwErr );
		_tcscat_s( temp, n + 10, tcError );
	}

	nRet = MessageBox( hWnd, temp, szTitle, nType );
	delete[] temp;

	return nRet;
}
